SystemOrganization addCategory: #'Versionner-Cache'!
SystemOrganization addCategory: #'Versionner-Cache-Test'!

MCVersion subclass: #MBCacheVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

MBCacheVersion subclass: #MBPackageCacheVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBPackageCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 2/10/2012 12:37'!
fileOutOn: aStream with: aZip
	"write in zip project and dont flush the stream"
	| writer |
	writer := self writerClass on: aStream.
	writer packageName: (self info name).
	writer projectZip: aZip.
	writer writeVersion: self.! !

!MBPackageCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 2/10/2012 12:40'!
initializeWithPackage: aPackage info: aVersionInfo snapshot: aSnapshot dependencies: aCollection
	package := aPackage.
	info := aVersionInfo.
	snapshot := aSnapshot.
	dependencies := aCollection.! !

!MBPackageCacheVersion methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 11:15'!
writerClass
 	^ MBPackageCacheWriter ! !

MBCacheVersion subclass: #MBProjectCacheVersion
	instanceVariableNames: 'packageNames projectName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBProjectCacheVersion class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 3/24/2012 20:41'!
named: nameString message: messageString autor: autorString
	^ MBProjectCacheVersion new
			setPackage:  (MCPackage new name: nameString)
			info: (MCVersionInfo
				name: nameString
				id: UUID new
				message: messageString
				date: Date today
				time: Time now
				author: autorString
				ancestors: #())
			snapshot: (MCSnapshot fromDefinitions: (Array new))
			dependencies: #();
			projectName: nameString.! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 3/6/2012 17:09'!
addPackageVersion: aPackageName
	""
	packageNames add: aPackageName.! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 5/20/2012 23:30'!
fileOutOn: aStream
	| writer path counter|
	path := FileDirectory default pathName, '/package-cache/'.
	writer := self writerClass on: aStream.
	writer writeVersion: self.
	counter := 1.
	packageNames do:[ : aSpec| 
		[ 
		writer zip addFile: (path, aSpec file, '.mcz') as: (counter printString,'-', aSpec file,'.mcz') 
		
		] on: Error do:[  
			[writer zip addFile: (path, aSpec name , '.mcz')  as: (counter printString,'-',aSpec name , '.mcz')]
			on: Error do:[ "missing file"].
		].
		counter := counter +1.
	].
	writer flush.
	! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 3/6/2012 17:43'!
initialize 
	super initialize.
	packageNames := OrderedCollection new.! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 3/6/2012 17:43'!
packageVersions
	^ packageNames.! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:16'!
projectName
	^projectName! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:16'!
projectName: aString
	projectName := aString! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 11:15'!
writerClass
 	^ MBProjectCacheWriter! !

MCMczWriter subclass: #MBPackageCacheWriter
	instanceVariableNames: 'packageName projectZip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
addString: string at: path
	| member |
	member := projectZip addString: string as: path.
	member desiredCompressionMethod: ZipArchive compressionDeflated 
	! !

!MBPackageCacheWriter methodsFor: 'accessing' stamp: 'JPSA 2/6/2012 10:17'!
packageName
	^ packageName! !

!MBPackageCacheWriter methodsFor: 'accessing' stamp: 'JPSA 2/6/2012 10:17'!
packageName: anObject
	packageName := anObject! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
projectZip: aZip
	projectZip := aZip.! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
writePackage: aPackage
	self addString: (self serializePackage: aPackage) at: (packageName, '/package')! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
writeSnapshot: aSnapshot
	self addString: (self serializeDefinitions: aSnapshot definitions) at: (packageName,'/snapshot/source.'), self snapshotWriterClass extension.
	self addString: (self serializeInBinary: aSnapshot) at: (packageName ,'/snapshot.bin')! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
writeVersionDependency: aVersionDependency
	| string |
	string := (self serializeVersionInfo: aVersionDependency versionInfo).
	self addString: string at: (packageName,'/dependencies/'), aVersionDependency package name! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
writeVersionInfo: aVersionInfo
	| string |
	string := self serializeVersionInfo: aVersionInfo.
	self addString: string at: (packageName , '/version').
! !

TestCase subclass: #TestCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache-Test'!

!TestCache methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 5/18/2012 15:33'!
testRead
	
	Gofer new
     		url:'http://ss3.gemstone.com/ss/VersionnerCacheTest';
    		package: 'Cache-ConfigurationOfProfStef-1160049.mcz';
     		execute: MBGoferCacheLoad.! !

MBConfigurationInfoCommand subclass: #MBLoadCacheCommand
	instanceVariableNames: 'repository cacheName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBLoadCacheCommand class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 5/18/2012 22:29'!
in: anUrlString named: aString
	|inst|
	inst := self new.
	inst repository: (MCHttpRepository location: anUrlString user: '' password: '').
	inst cacheName: aString.
	^ inst.
	! !

!MBLoadCacheCommand methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 5/18/2012 22:15'!
cacheName

	^ cacheName! !

!MBLoadCacheCommand methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 5/18/2012 22:15'!
cacheName: anObject

	cacheName := anObject! !

!MBLoadCacheCommand methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 5/21/2012 01:06'!
documentation
	^ ''.! !

!MBLoadCacheCommand methodsFor: 'execute' stamp: 'JuanPabloSandovalA 5/21/2012 01:04'!
execute
	
	|version sortedPackages|

	version := repository versionReaderForFileNamed: (self cacheName).
	sortedPackages := (version zip membersMatching: '*.mcz') 
		asSortedCollection:[ :A :B | 
			(A fileName subStrings: '-') first asInteger 
			< 
			(B fileName subStrings: '-') first asInteger ].
	 sortedPackages do: [ :member |
			(MCMczReader versionFromStream: (member contentStream)) load.
		].! !

!MBLoadCacheCommand methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 5/18/2012 22:15'!
repository

	^ repository! !

!MBLoadCacheCommand methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 5/18/2012 22:15'!
repository: anObject

	repository := anObject! !

!MBLoadCacheCommand methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 5/18/2012 22:19'!
versionNamed: aString from:  aRepository

	^ aRepository versionReaderForFileNamed: aString.! !

MBConfigurationInfoCommand subclass: #MBSaveAsCacheCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBSaveAsCacheCommand methodsFor: 'documentation' stamp: 'JPSA 2/6/2012 10:36'!
documentation 
	^ 'Add a new cache in the selected configuration'! !

!MBSaveAsCacheCommand methodsFor: 'execute' stamp: 'JuanPabloSandovalA 5/21/2012 00:26'!
execute
	| message projectCache|
	message := MBPlatform current multilineRequest: 'Enter message for cached version' initialAnswer: ''.
	message ifNil:[ ^ self.].
	self checkUserInRepositoryOfPackage: self configurationClass name asString.
	projectCache := 
	MBProjectCacheVersion 
		named: ('Cache-' , self configurationClass name asString, '-' , Time millisecondClockValue asString)  
		message: message  
		autor: target version author. 
	(self filesOf: target) do:[ : p |  projectCache addPackageVersion: p].
	self repository storeVersion: projectCache.! !

!MBSaveAsCacheCommand methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 5/21/2012 00:26'!
filesOf: aConfiguration
	"
	(ConfigurationOfMondrian project lastVersion  allPackagesForSpecNamed: 'ALL') collect: [ :pfs|  pfs file]
	"
	^ aConfiguration currentVersion spec packages packageSpecsInLoadOrder.! !

!MBSaveAsCacheCommand methodsFor: 'accessing' stamp: 'JPSA 2/6/2012 11:28'!
repository
	"Return the repository of the configuration. Create one (using UI) if necessary"

	^self chooseRepositoryFromList: target repositories! !

!MBSaveAsCacheCommand methodsFor: 'accessing' stamp: 'JPSA 2/6/2012 10:37'!
title
	^ 'save all and add new cache version'! !
